function [corrcoeff_final] = challenge_run_xcorr(ecgc,QRS2)
%
% Sample entry for the 2017 PhysioNet/CinC Challenge.
%
% INPUTS:
% recordName: string specifying the record name to process
%
% OUTPUTS:
% classifyResult: integer value where
%                     N = normal rhythm
%                     A = AF
%                     O = other rhythm
%                     ~ = noisy recording (poor signal quality)
%
% To run your entry on the entire training set in a format that is
% compatible with PhysioNet's scoring enviroment, run the script
% generateValidationSet.m
%
% The challenge function requires that you have downloaded the challenge
% data 'training_set' in a subdirectory of the current directory.
%    http://physionet.org/physiobank/database/challenge/2017/
%
% This dataset is used by the generateValidationSet.m script to create
% the annotations on your training set that will be used to verify that
% your entry works properly in the PhysioNet testing environment.
%
%
% Version 1.0
%
%
% Written by: Chengyu Liu and Qiao Li January 20 2017
%             chengyu.liu@emory.edu  qiao.li@emory.edu
%
% Last modified by:
%
%
  

 
 if (length(ecgc)>1 && length(QRS2)>2)
[template,candid_tool]=find_template_af(ecgc,QRS2);
          for j=1:length(QRS2)-1 
   
    g=ecgc(QRS2(j):QRS2(j+1));
    
   h=template;


 g_align=resample(g,candid_tool,length(g));
%  h_align=resample(h,candid_tool,length(h));
corrcoef=0;
if (length(h)>2 && length(g_align)>2 && length(h)==length(g_align))

corrcoef=corr2(g_align,h);

end
corrcoeff_final{j,1}=corrcoef;

          end
 else
   corrcoeff_final={0}; 
        

% iqr_corrcoef=iqr(corrcoeff_final(:,1)); 
% mean_corrcoef=mean(corrcoeff_final(:,1)); 
% feature_corcoeff=[iqr_corrcoef,mean_corrcoef];
        

  
       end
 end





% end


