%%%creating neural network to detect normal samples

% This script assumes these variables are defined:
%
%   features_traina_trainb - input data.
%   targets_traina_trainb - target data.

x =feature1;
t =target1;

% Create a Pattern Recognition Network
hiddenLayerSize =[8];
net1 = patternnet(hiddenLayerSize);

% Choose Input and Output Pre/Post-Processing Functions
% For a list of all processing functions type: help nnprocess
net1.input.processFcns = {'removeconstantrows','mapminmax'};
net1.output.processFcns = {'removeconstantrows','mapminmax'};


% Setup Division of Data for Training, Validation, Testing
% For a list of all data division functions type: help nndivide
net1.divideFcn = 'dividerand';  % Divide data randomly
net1.divideMode = 'sample';  % Divide up every sample
net1.divideParam.trainRatio = 70/100;
net1.divideParam.valRatio = 15/100;
net1.divideParam.testRatio = 15/100;

% Scaled conjugate gradient
net1.trainFcn = 'trainr';  
 net1.trainParam.epochs=10;
% Choose a Performance Function

net1.performFcn = 'crossentropy';  % Cross-entropy

% Choose Plot Functions
% For a list of all plot functions type: help nnplot
net1.plotFcns = {'plotperform','plottrainstate','ploterrhist', ...
  'plotregression', 'plotfit','plotconfusion'};


% Train the Network
[net1,tr] = train(net1,x,t);

% Test the Network
y = net1(x);
e = gsubtract(t,y);
tind = vec2ind(t);
yind = vec2ind(y);
percentErrors = sum(tind ~= yind)/numel(tind);
performance = perform(net1,t,y);

% Recalculate Training, Validation and Test Performance
trainTargets = t .* tr.trainMask{1};
valTargets = t  .* tr.valMask{1};
testTargets = t  .* tr.testMask{1};
trainPerformance = perform(net1,trainTargets,y);
valPerformance = perform(net1,valTargets,y);
testPerformance = perform(net1,testTargets,y);

% View the Network
view(net1)

% Plots
% Uncomment these lines to enable various plots.
%figure, plotperform(tr)
%figure, plottrainstate(tr)
figure, plotconfusion(t,y)
%figure, plotroc(t,y)
%figure, ploterrhist(e)

% Deployment
% Change the (false) values to (true) to enable the following code blocks.
if (false)
  % Generate MATLAB function for neural network for application deployment
  % in MATLAB scripts or with MATLAB Compiler and Builder tools, or simply
  % to examine the calculations your trained neural network performs.
  genFunction(net,'myNeuralNetworkFunction');
  y = myNeuralNetworkFunction(x);
end
if (false)
  % Generate a matrix-only MATLAB function for neural network code
  % generation with MATLAB Coder tools.
  genFunction(net,'myNeuralNetworkFunction','MatrixOnly','yes');
  y = myNeuralNetworkFunction(x);
end
if (false)
  % Generate a Simulink diagram for simulation or deployment with.
  % Simulink Coder tools.
  gensim(net);
end
% testX = x(:,tr.testInd);
% testT = t(:,tr.testInd);
% 
% testY = net1(testX);
% plotconfusion(testT,testY)

%%
% Here are the overall percentages of correct and incorrect classification.

% [c,cm] = confusion(testT,testY);
% 
% fprintf('Percentage Correct Classification   : %f%%\n', 100*(1-c));
% fprintf('Percentage Incorrect Classification : %f%%\n', 100*c);
% plotconfusion(testT,testY)
% plotroc(testT,testY)


